package com.gic.haoban.manage.service.service.hm.impl;

import java.util.Date;

import org.apache.logging.log4j.LogManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.UniqueIdUtils;
import com.gic.haoban.manage.api.dto.hm.HmLinkVisitLogDTO;
import com.gic.haoban.manage.service.dao.mapper.hm.HmLinkMapper;
import com.gic.haoban.manage.service.dao.mapper.hm.HmLinkVisitLogMapper;
import com.gic.haoban.manage.service.entity.hm.TabHmLink;
import com.gic.haoban.manage.service.entity.hm.TabHmLinkVisitLog;
import com.gic.haoban.manage.service.service.hm.HmLinkVisitLogService;

@Service("hmLinkVisitLogService")
public class HmLinkVisitLogServiceImpl implements HmLinkVisitLogService {

    private static org.apache.logging.log4j.Logger log = LogManager.getLogger(HmLinkVisitLogService.class);

    @Autowired
    private HmLinkVisitLogMapper hmLinkVisitLogMapper;
    @Autowired
    private HmLinkMapper hmLinkMapper;

    @Override
    public void save(HmLinkVisitLogDTO dto) {
        Long linkId = dto.getLinkId();
        TabHmLink link = this.hmLinkMapper.selectById(linkId);
        if (null == link) {
            log.info("链接不存在,linkId={}", linkId);
            return;
        }
        TabHmLinkVisitLog entity = EntityUtil.changeEntityByJSON(TabHmLinkVisitLog.class, dto);
        entity.setCreateTime(new Date());
        entity.setWxEnterpriseId(link.getWxEnterpriseId());
        entity.setEnterpriseId(link.getEnterpriseId());
        entity.setLogId(UniqueIdUtils.uniqueLong());
        this.hmLinkVisitLogMapper.insert(entity);
    }

}
